#include "2include.h"

float pythag(a,b)
float a,b;
{
        float absa,absb;
        absa=fabs(a);
        absb=fabs(b);
        if (absa > absb) return absa*sqrt(1.0+SQR(absb/absa));
        else return (absb == 0.0 ? 0.0 : absb*sqrt(1.0+SQR(absa/absb)));
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */


void svdcmp(a,m,n,w,v)
float **a,**v,w[];
int m,n;
{
        float pythag();
        int flag,i,its,j,jj,k,l,nm;
        float anorm,c,f,g,h,s,scale,x,y,z,*rv1;

        rv1=vector(1,n);
        g=scale=anorm=0.0;
        for (i=1;i<=n;i++) {
                l=i+1;
                rv1[i]=scale*g;
                g=s=scale=0.0;
                if (i <= m) {
                        for (k=i;k<=m;k++) scale += fabs(a[k][i]);
                        if (scale) {
                                for (k=i;k<=m;k++) {
                                        a[k][i] /= scale;
                                        s += a[k][i]*a[k][i];
                                }
                                f=a[i][i];
                                g = -SIGN(sqrt(s),f);
                                h=f*g-s;
                                a[i][i]=f-g;
                                for (j=l;j<=n;j++) {
                                        for (s=0.0,k=i;k<=m;k++) s += a[k][i]*a[k][j];
                                        f=s/h;
                                        for (k=i;k<=m;k++) a[k][j] += f*a[k][i];
                                }
                                for (k=i;k<=m;k++) a[k][i] *= scale;
                        }
                }
                w[i]=scale *g;
                g=s=scale=0.0;
                if (i <= m && i != n) {
                        for (k=l;k<=n;k++) scale += fabs(a[i][k]);
                        if (scale) {
                                for (k=l;k<=n;k++) {
                                        a[i][k] /= scale;
                                        s += a[i][k]*a[i][k];
                                }
                                f=a[i][l];
                                g = -SIGN(sqrt(s),f);
                                h=f*g-s;
                                a[i][l]=f-g;
                                for (k=l;k<=n;k++) rv1[k]=a[i][k]/h;
                                for (j=l;j<=m;j++) {
                                        for (s=0.0,k=l;k<=n;k++) s += a[j][k]*a[i][k];
                                        for (k=l;k<=n;k++) a[j][k] += s*rv1[k];
                                }
                                for (k=l;k<=n;k++) a[i][k] *= scale;
                        }
                }
                anorm=FMAX(anorm,(fabs(w[i])+fabs(rv1[i])));
        }
        for (i=n;i>=1;i--) {
                if (i < n) {
                        if (g) {
                                for (j=l;j<=n;j++)
                                        v[j][i]=(a[i][j]/a[i][l])/g;
                                for (j=l;j<=n;j++) {
                                        for (s=0.0,k=l;k<=n;k++) s += a[i][k]*v[k][j];
                                        for (k=l;k<=n;k++) v[k][j] += s*v[k][i];
                                }
                        }
                        for (j=l;j<=n;j++) v[i][j]=v[j][i]=0.0;
                }
                v[i][i]=1.0;
                g=rv1[i];
                l=i;
        }
        for (i=IMIN(m,n);i>=1;i--) {
                l=i+1;
                g=w[i];
                for (j=l;j<=n;j++) a[i][j]=0.0;
                if (g) {
                        g=1.0/g;
                        for (j=l;j<=n;j++) {
                                for (s=0.0,k=l;k<=m;k++) s += a[k][i]*a[k][j];
                                f=(s/a[i][i])*g;
                                for (k=i;k<=m;k++) a[k][j] += f*a[k][i];
                        }
                        for (j=i;j<=m;j++) a[j][i] *= g;
                } else for (j=i;j<=m;j++) a[j][i]=0.0;
                ++a[i][i];
        }
        for (k=n;k>=1;k--) {
                for (its=1;its<=30;its++) {
                        flag=1;
                        for (l=k;l>=1;l--) {
                                nm=l-1;
                                if ((float)(fabs(rv1[l])+anorm) == anorm) {
                                        flag=0;
                                        break;
                                }
                                if ((float)(fabs(w[nm])+anorm) == anorm) break;
                        }
                        if (flag) {
                                c=0.0;
                                s=1.0;
                                for (i=l;i<=k;i++) {
                                        f=s*rv1[i];
                                        rv1[i]=c*rv1[i];
                                        if ((float)(fabs(f)+anorm) == anorm) break;
                                        g=w[i];
                                        h=pythag(f,g);
                                        w[i]=h;
                                        h=1.0/h;
                                        c=g*h;
                                        s = -f*h;
                                        for (j=1;j<=m;j++) {
                                                y=a[j][nm];
                                                z=a[j][i];
                                                a[j][nm]=y*c+z*s;
                                                a[j][i]=z*c-y*s;
                                        }
                                }
                        }
                        z=w[k];
                        if (l == k) {
                                if (z < 0.0) {
                                        w[k] = -z;
                                        for (j=1;j<=n;j++) v[j][k] = -v[j][k];
                                }
                                break;
                        }
                        if (its == 30) nrerror("no convergence in 30 svdcmp iterations");
                        x=w[l];
                        nm=k-1;
                        y=w[nm];
                        g=rv1[nm];
                        h=rv1[k];
                        f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y);
                        g=pythag(f,1.0);
                        f=((x-z)*(x+z)+h*((y/(f+SIGN(g,f)))-h))/x;
                        c=s=1.0;
                        for (j=l;j<=nm;j++) {
                                i=j+1;
                                g=rv1[i];
                                y=w[i];
                                h=s*g;
                                g=c*g;
                                z=pythag(f,h);
                                rv1[j]=z;
                                c=f/z;
                                s=h/z;
                                f=x*c+g*s;
                                g = g*c-x*s;
                                h=y*s;
                                y *= c;
                                for (jj=1;jj<=n;jj++) {
                                        x=v[jj][j];
                                        z=v[jj][i];
                                        v[jj][j]=x*c+z*s;
                                        v[jj][i]=z*c-x*s;
                                }
                                z=pythag(f,h);
                                w[j]=z;
                                if (z) {
                                        z=1.0/z;
                                        c=f*z;
                                        s=h*z;
                                }
                                f=c*g+s*y;
                                x=c*y-s*g;
                                for (jj=1;jj<=m;jj++) {
                                        y=a[jj][j];
                                        z=a[jj][i];
                                        a[jj][j]=y*c+z*s;
                                        a[jj][i]=z*c-y*s;
                                }
                        }
                        rv1[l]=0.0;
                        rv1[k]=f;
                        w[k]=x;
                }
        }
        free_vector(rv1,1,n);
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */


float gasdev(idum)
long *idum;
{
        float ran2();
        static int iset=0;
        static float gset;
        float fac,rsq,v1,v2;

        if  (iset == 0) {
                do {
                        v1=2.0*ran2(idum)-1.0;
                        v2=2.0*ran2(idum)-1.0;
                        rsq=v1*v1+v2*v2;
                } while (rsq >= 1.0 || rsq == 0.0);
                fac=sqrt(-2.0*log(rsq)/rsq);
                gset=v1*fac;
                iset=1;
                return v2*fac;
        } else {
                iset=0;
                return gset;
        }
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */

void nrerror(error_text)
char error_text[];
{
   void exit();

   fprintf(stderr,"Numerical Recipes run-time error...\n");
   fprintf(stderr,"%s\n",error_text);
   fprintf(stderr,"...now exiting to system...\n");
   exit(1);
}



float *vector(nl,nh)
int nl,nh;
{
   float *v;

   v=(float *)malloc((unsigned) (nh-nl+1)*sizeof(float));
   if (!v) nrerror("allocation failure in vector()");
   return v-nl;
}

int *ivector(nl,nh)
int nl,nh;
{
   int *v;

   v=(int *)malloc((unsigned) (nh-nl+1)*sizeof(int));
   if (!v) nrerror("allocation failure in vector()");
   return v-nl;
}

long *lvector(nl,nh)
long nl,nh;
{
   long *v;

   v=(long *)malloc((unsigned) (nh-nl+1)*sizeof(long));
   if (!v) nrerror("allocation failure in vector()");
   return v-nl;
}


float **matrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
   int i;
   float **m;

   m=(float **) malloc((unsigned) (nrh-nrl+1)*sizeof(float*));
   if (!m) nrerror("allocation failure 1 in matrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
      m[i]=(float *) malloc((unsigned) (nch-ncl+1)*sizeof(float));
      if (!m[i]) nrerror("allocation failure 2 in matrix()");
      m[i] -= ncl;
   }
   return m;
}

float **flmatrix(nrl,nrh,ncl,nch)
long nrl,nrh,ncl,nch;
{
   long i;
   float **m;

   m=(float **) malloc((unsigned) (nrh-nrl+1)*sizeof(float*));
   if (!m) nrerror("allocation failure 1 in matrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
      m[i]=(float *) malloc((unsigned) (nch-ncl+1)*sizeof(float));
      if (!m[i]) nrerror("allocation failure 2 in matrix()");
      m[i] -= ncl;
   }
   return m;
}

int **imatrix(nrl,nrh,ncl,nch)
int nrl,nrh,ncl,nch;
{
   int i;
   int **m;

   m=(int **) malloc((unsigned) (nrh-nrl+1)*sizeof(int*));
   if (!m) nrerror("allocation failure 1 in matrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
      m[i]=(int *) malloc((unsigned) (nch-ncl+1)*sizeof(int));
      if (!m[i]) nrerror("allocation failure 2 in matrix()");
      m[i] -= ncl;
   }
   return m;
}

long **lmatrix(nrl,nrh,ncl,nch)
long nrl,nrh,ncl,nch;
{
   long i;
   long **m;

   m=(long **) malloc((unsigned) (nrh-nrl+1)*sizeof(long*));
   if (!m) nrerror("allocation failure 1 in matrix()");
   m -= nrl;

   for(i=nrl;i<=nrh;i++) {
      m[i]=(long *) malloc((unsigned) (nch-ncl+1)*sizeof(long));
      if (!m[i]) nrerror("allocation failure 2 in matrix()");
      m[i] -= ncl;
   }
   return m;
}



void free_vector(v,nl,nh)
float *v;
int nl,nh;
{
   free((char*) (v+nl));
}

void free_ivector(v,nl,nh)
int *v;
int nl,nh;
{
   free((char*) (v+nl));
}

void free_lvector(v,nl,nh)
long *v;
long nl,nh;
{
   free((char*) (v+nl));
}

void free_matrix(m,nrl,nrh,ncl,nch)
float **m;
int nrl,nrh,ncl,nch;
{
   int i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}

void free_flmatrix(m,nrl,nrh,ncl,nch)
float **m;
long nrl,nrh,ncl,nch;
{
   long i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}


void free_imatrix(m,nrl,nrh,ncl,nch)
int **m;
int nrl,nrh,ncl,nch;
{
   int i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}

void free_lmatrix(m,nrl,nrh,ncl,nch)
long **m;
long nrl,nrh,ncl,nch;
{
   long i;

   for(i=nrh;i>=nrl;i--) free((char*) (m[i]+ncl));
   free((char*) (m+nrl));
}



/*
mltmm multiples the matrices m1 * m2 = m3;
m1 is i1 by i2; m2 is i2 by i3; m3 is i1 by i3.
*/
float mltmm(m1,i1,i2,m2,i3,m3)
float **m1, **m2, **m3;
int i1, i2, i3;
{
   int i, j, k;
   float tmp;
   for(i = 1; i <= i1; i++){
      for(j = 1; j <= i3; j++){
         tmp = 0;
         for(k = 1; k <= i2; k++) tmp += m1[i][k] * m2[k][j];
         m3[i][j] = tmp;
      }
   }
}

/*
mltmv multiples the matrices m1 and the vector v2.
      m1 * v2 = v3.
m1 is i1 by i2; lenght(v2) = i2 long; length(v3) = i1.
*/
float mltmv(m1,i1,i2,v2,v3)
float **m1, *v2, *v3;
int i1, i2;
{
   int i, j;
   float tmp;
   for(i = 1; i <= i1; i++){
      tmp = 0;
      for(j = 1; j <= i2; j++) tmp += m1[i][j] * v2[j];
      v3[i] = tmp;
   }
}

/*
mlttmm multiples the matrices transpose(m1) * m2 = m3;
m1 is i1 by i2; m2 is i1 by i3; m3 is i2 by i3.
*/
float mlttmm(m1,i1,i2,m2,i3,m3)
float **m1, **m2, **m3;
int i1, i2, i3;
{
   int i, j, k;
   float tmp;
   for(i = 1; i <= i2; i++){
      for(j = 1; j <= i3; j++){
         tmp = 0;
         for(k = 1; k <= i1; k++) tmp += m1[k][i] * m2[k][j];
         m3[i][j] = tmp;
      }
   }
}

/*
mltmmt multiples the matrices m1 * transpose(m2) = m3;
m1 is i1 by i2; m2 is i3 by i2; m3 is i1 by i3.
*/
float mltmmt(m1,i1,i2,m2,i3,m3)
float **m1, **m2, **m3;
int i1, i2, i3;
{
   int i, j, k;
   float tmp;
   for(i = 1; i <= i1; i++){
      for(j = 1; j <= i3; j++){
         tmp = 0;
         for(k = 1; k <= i2; k++) tmp += m1[i][k] * m2[j][k];
         m3[i][j] = tmp;
      }
   }
}


//inversse computes the inverse of a square (n x n) non-singular matrix
//  The inverse is returned in ai.
//BEGIN inversse
void inversse(a, n, ai)
int n;
float **a, **ai; 
{

int i, i1, i2, i3;
float tmp;
float *w;
float **v;
float **athis;

float wmax;
float wmin;

w = vector(1,n);
v = matrix(1,n,1,n);
athis = matrix(1,n,1,n);

//Make a copy of a to give to svdcmp so that a
//  is not replaced by the  u returned by svdcmp.
for(i1=1; i1 <=n; i1++){
for(i2=1; i2 <=n; i2++){
athis[i1][i2] = a[i1][i2];
ai[i1][i2] = 0;
v[i1][i2] = 0;
}
}

svdcmp(athis,n,n,w,v);

wmax = w[1];
wmin = w[1];

for(i = 2; i <= n; i++){
if(w[i] > wmax){ wmax = w[i];}
if(w[i] < wmin){ wmin = w[i];}
}

if((wmin / wmax) <  10E-13){
printf("\n");
printf("\n");
printf("|WARNING:  The matrix is close to being singular.\n");
printf("|            The computations done here might be seriously affected\n");
printf("|            by the limits of the machine precision.\n");
printf("|          Those singular values < (10E-13)*maxSingularValue\n");
printf("|            are being set = 0 along with their reciprocals\n"); 
printf("|            and the computation of the inverse of the matrix\n");
printf("|            is continuing.\n");


for(i1=1; i1 <=n; i1++){
if(w[i1] < 10E-13 * wmax){ w[i1] = 0;}
}
}

for(i1=1; i1 <=n; i1++){
for(i2=1; i2 <=i1; i2++){
tmp = athis[i1][i2];
athis[i1][i2] = athis[i2][i1];
athis[i2][i1] = tmp;
}
}

for(i1=1; i1 <=n; i1++){
for(i2=1; i2 <= n; i2++){
if(w[i1] != 0){
athis[i1][i2] *= (1/w[i1]);
}
else{
athis[i1][i2] *= 0;
}
}
}

mltmm(v,n,n,athis,n,ai);

free_vector(w,1,n);
free_matrix(v,1,n,1,n);
free_matrix(athis,1,n,1,n);
}//END inversse



#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0/IM1)
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)
float ran2(idum)
long *idum;
{
   int j;
   long k;
   static long idum2=123456789;
   static long iy=0;
   static long iv[NTAB];
   float temp;

   if (*idum <= 0) {
      if (-(*idum) < 1) *idum=1;
      else *idum = -(*idum);
      idum2=(*idum);
      for (j=NTAB+7;j>=0;j--) {
         k=(*idum)/IQ1;
         *idum=IA1*(*idum-k*IQ1)-k*IR1;
         if (*idum < 0) *idum += IM1;
         if (j < NTAB) iv[j] = *idum;
      }
      iy=iv[0];
   }
   k=(*idum)/IQ1;
   *idum=IA1*(*idum-k*IQ1)-k*IR1;
   if (*idum < 0) *idum += IM1;
   k=idum2/IQ2;
   idum2=IA2*(idum2-k*IQ2)-k*IR2;
   if (idum2 < 0) idum2 += IM2;
   j=iy/NDIV;
   iy=iv[j]-idum2;
   iv[j] = *idum;
   if (iy < 1) iy += IMM1;
   if ((temp=AM*iy) > RNMX) return RNMX;
   else return temp;
}
#undef IM1
#undef IM2
#undef AM
#undef IMM1
#undef IA1
#undef IA2
#undef IQ1
#undef IQ2
#undef IR1
#undef IR2
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */

pd(a,k)
double *a;
int k;
{ 
   int i; 
   for (i=1; i<=k;i++) printf("%10.4lf",a[i]);
   printf("\n");
}
pl(a,k)
long *a;
int k;
{ 
   int i; 
   for (i=1; i<=k;i++) printf(" %10ld",a[i]);
   printf("\n");
}

pi(a,k)
int *a,k;
{ 
   int i; 
   for (i=1; i<=k;i++) printf(" %10d",a[i]);
   printf("\n");
}


pf(a,k)
float *a;
int k;
{ 
   int i; 
   for (i=1; i<=k;i++) printf(" %10f",a[i]);
   printf("\n");
}
pmi(a,k,l)
int **a;
int k,l;
{
   int i,j;
   printf("\n");
   for(i = 1; i <= k; i++){
      for(j = 1; j <= l; j++) printf(" %9d",a[i][j]);
      printf("\n");
   }
}
pmf(a,k,l)
float **a;
int k,l;
{
   int i,j;
   printf("\n");
   for(i = 1; i <= k; i++){
      for(j = 1; j <= l; j++) printf(" %15.10f",a[i][j]);
      printf("\n");
   }
}

#define ITMAX 100
#define CGOLD 0.3819660
#define ZEPS 1.0e-10
#define SHFT(a,b,c,d) (a)=(b);(b)=(c);(c)=(d);

float brent(ax,bx,cx,f,tol,xmin)
float (*f)(),*xmin,ax,bx,cx,tol;
{
        int iter;
        float a,b,d,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm;
        float e=0.0;

        a=(ax < cx ? ax : cx);
        b=(ax > cx ? ax : cx);
        x=w=v=bx;
        fw=fv=fx=(*f)(x);
        for (iter=1;iter<=ITMAX;iter++) {
                xm=0.5*(a+b);
                tol2=2.0*(tol1=tol*fabs(x)+ZEPS);
                if (fabs(x-xm) <= (tol2-0.5*(b-a))) {
                        *xmin=x;
                        return fx;
                }
                if (fabs(e) > tol1) {
                        r=(x-w)*(fx-fv);
                        q=(x-v)*(fx-fw);
                        p=(x-v)*q-(x-w)*r;
                        q=2.0*(q-r);
                        if (q > 0.0) p = -p;
                        q=fabs(q);
                        etemp=e;
                        e=d;
                        if (fabs(p) >= fabs(0.5*q*etemp) || p <= q*(a-x) || p >= q*(b-x))
                                d=CGOLD*(e=(x >= xm ? a-x : b-x));
                        else {
                                d=p/q;
                                u=x+d;
                                if (u-a < tol2 || b-u < tol2)
                                        d=SIGN(tol1,xm-x);
                        }
                } else {
                        d=CGOLD*(e=(x >= xm ? a-x : b-x));
                }
                u=(fabs(d) >= tol1 ? x+d : x+SIGN(tol1,d));
                fu=(*f)(u);
                if (fu <= fx) {
                        if (u >= x) a=x; else b=x;
                        SHFT(v,w,x,u)
                        SHFT(fv,fw,fx,fu)
                } else {
                        if (u < x) a=u; else b=u;
                        if (fu <= fw || w == x) {
                                v=w;
                                w=u;
                                fv=fw;
                                fw=fu;
                        } else if (fu <= fv || v == x || v == w) {
                                v=u;
                                fv=fu;
                        }
                }
        }
        nrerror("Too many iterations in brent");
        *xmin=x;
        return fx;
}
#undef ITMAX
#undef CGOLD
#undef ZEPS
#undef SHFT
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */

extern int ncom;
extern float *pcom,*xicom,(*nrfunc)();

float f1dim(x)
float x;
{
        int j;
        float f,*xt;

        xt=vector(1,ncom);
        for (j=1;j<=ncom;j++) xt[j]=pcom[j]+x*xicom[j];
        f=(*nrfunc)(xt);
        free_vector(xt,1,ncom);
        return f;
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */
#define TOL 2.0e-4

int ncom;
float *pcom,*xicom,(*nrfunc)();

void linmin(p,xi,n,fret,func)
float (*func)(),*fret,p[],xi[];
int n;
{
        float brent(),f1dim();
        void mnbrak();
        int j;
        float xx,xmin,fx,fb,fa,bx,ax;

        ncom=n;
        pcom=vector(1,n);
        xicom=vector(1,n);
        nrfunc=func;
        for (j=1;j<=n;j++) {
                pcom[j]=p[j];
                xicom[j]=xi[j];
        }
        ax=0.0;
        xx=1.0;
        mnbrak(&ax,&xx,&bx,&fa,&fx,&fb,f1dim);
        *fret=brent(ax,xx,bx,f1dim,TOL,&xmin);
        for (j=1;j<=n;j++) {
                xi[j] *= xmin;
                p[j] += xi[j];
        }
        free_vector(xicom,1,n);
        free_vector(pcom,1,n);
}
#undef TOL
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */
#define GOLD 1.618034
#define GLIMIT 100.0
#define TINY 1.0e-20
#define SHFT(a,b,c,d) (a)=(b);(b)=(c);(c)=(d);

void mnbrak(ax,bx,cx,fa,fb,fc,func)
float (*func)(),*ax,*bx,*cx,*fa,*fb,*fc;
{
        float ulim,u,r,q,fu,dum;

        *fa=(*func)(*ax);
        *fb=(*func)(*bx);
        if (*fb > *fa) {
                SHFT(dum,*ax,*bx,dum)
                SHFT(dum,*fb,*fa,dum)
        }
        *cx=(*bx)+GOLD*(*bx-*ax);
        *fc=(*func)(*cx);
        while (*fb > *fc) {
                r=(*bx-*ax)*(*fb-*fc);
                q=(*bx-*cx)*(*fb-*fa);
                u=(*bx)-((*bx-*cx)*q-(*bx-*ax)*r)/
                        (2.0*SIGN(FMAX(fabs(q-r),TINY),q-r));
                ulim=(*bx)+GLIMIT*(*cx-*bx);
                if ((*bx-u)*(u-*cx) > 0.0) {
                        fu=(*func)(u);
                        if (fu < *fc) {
                                *ax=(*bx);
                                *bx=u;
                                *fa=(*fb);
                                *fb=fu;
                                return;
                        } else if (fu > *fb) {
                                *cx=u;
                                *fc=fu;
                                return;
                        }
                        u=(*cx)+GOLD*(*cx-*bx);
                        fu=(*func)(u);
                } else if ((*cx-u)*(u-ulim) > 0.0) {
                        fu=(*func)(u);
                        if (fu < *fc) {
                                SHFT(*bx,*cx,u,*cx+GOLD*(*cx-*bx))
                                SHFT(*fb,*fc,fu,(*func)(u))
                        }
                } else if ((u-ulim)*(ulim-*cx) >= 0.0) {
                        u=ulim;
                        fu=(*func)(u);
                } else {
                        u=(*cx)+GOLD*(*cx-*bx);
                        fu=(*func)(u);
                }
                SHFT(*ax,*bx,*cx,u)
                SHFT(*fa,*fb,*fc,fu)
        }
}
#undef GOLD
#undef GLIMIT
#undef TINY
#undef SHFT
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */
#define ITMAX 200

void powell(p,xi,n,ftol,iter,fret,func)
float (*func)(),**xi,*fret,ftol,p[];
int *iter,n;
{
        void linmin();
        int i,ibig,j;
        float del,fp,fptt,t,*pt,*ptt,*xit;

        pt=vector(1,n);
        ptt=vector(1,n);
        xit=vector(1,n);
        *fret=(*func)(p);
        for (j=1;j<=n;j++) pt[j]=p[j];
        for (*iter=1;;++(*iter)) {
                fp=(*fret);
                ibig=0;
                del=0.0;
                for (i=1;i<=n;i++) {
                        for (j=1;j<=n;j++) xit[j]=xi[j][i];
                        fptt=(*fret);
                        linmin(p,xit,n,fret,func);
                        if (fabs(fptt-(*fret)) > del) {
                                del=fabs(fptt-(*fret));
                                ibig=i;
                        }
                }
                if (2.0*fabs(fp-(*fret)) <= ftol*(fabs(fp)+fabs(*fret))) {
                        free_vector(xit,1,n);
                        free_vector(ptt,1,n);
                        free_vector(pt,1,n);
                        return;
                }
                if (*iter == ITMAX) nrerror("powell exceeding maximum iterations.");
                for (j=1;j<=n;j++) {
                        ptt[j]=2.0*p[j]-pt[j];
                        xit[j]=p[j]-pt[j];
                        pt[j]=p[j];
                }
                fptt=(*func)(ptt);
                if (fptt < fp) {
                        t=2.0*(fp-2.0*(*fret)+fptt)*SQR(fp-(*fret)-del)-del*SQR(fp-fptt);
                        if (t < 0.0) {
                                linmin(p,xit,n,fret,func);
                                for (j=1;j<=n;j++) {
                                        xi[j][ibig]=xi[j][n];
                                        xi[j][n]=xit[j];
                                }
                        }
                }
        }
}
#undef ITMAX
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */

void locate(xx,n,x,j)
float x,xx[];
unsigned long *j,n;
{
        unsigned long ju,jm,jl;
        int ascnd;

        jl=0;
        ju=n+1;
        ascnd=(xx[n] > xx[1]);
        while (ju-jl > 1) {
                jm=(ju+jl) >> 1;
                if (x > xx[jm] == ascnd)
                        jl=jm;
                else
                        ju=jm;
        }
        *j=jl;
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */

void hpsortjh(n,ra, dk, cens, timme)
float ra[], **timme;
int **cens, *dk;
unsigned long n;
{
        unsigned long i,ir,j,l;
        float rra;
        float *ttimme;
        int *ccens;
        int ddk;

        if (n < 2) return;
        l=(n >> 1)+1;
        ir=n;
        for (;;) {
                if (l > 1) {
                        rra=ra[--l];
                        ddk=dk[l];
                         ccens=cens[l];
                        ttimme=timme[l];
                } else {
                        rra=ra[ir];
                        ddk=dk[ir];
                        ccens=cens[ir];
                        ttimme=timme[ir];
                        ra[ir]=ra[1];
                        dk[ir]=dk[1];
                         cens[ir]=cens[1];
                        timme[ir]=timme[1];
                        if (--ir == 1) {
                                ra[1]=rra;
                                dk[1]=ddk;
                         cens[1]=ccens;
                        timme[1]=ttimme;
                                break;
                        }
                }
                i=l;
                j=l+l;
                while (j <= ir) {
                        if (j < ir && ra[j] < ra[j+1]) j++;
                        if (rra < ra[j]) {
                                ra[i]=ra[j];
                                dk[i]=dk[j];
                        cens[i]=cens[j];
                        timme[i]=timme[j];
                                i=j;
                                j <<= 1;
                        } else j=ir+1;
                }
                ra[i]=rra;
                dk[i]=ddk;
                        cens[i]=ccens;
                        timme[i]=ttimme;
        }
}
/* (C) Copr. 1986-92 Numerical Recipes Software *(. */
